/*
  ProgEx40a  -- Form3: Volume Of Your Box.  Responding To Button Presses.

  The only changes to this installment of our Form3 Volume Of Box program of ProgEx40 is
  the fleshing out of some button click logic in our WM_COMMAND message handler.  The
  totality of the changes are these 20 or so new lines of code...

  void btnCalculate_OnClick(lpWndEventArgs Wea)
  {
   MessageBox(Wea->hWnd, "You've Clicked The Calculate Button!", "Button Click Report", MB_OK);
  }

  void btnDisplay_OnClick(lpWndEventArgs Wea)
  {
   MessageBox(Wea->hWnd, "You've Clicked The Display Button!", "Button Click Report", MB_OK);
  }

  long fnWndProc_OnCommand(lpWndEventArgs Wea)
  {
   switch(LOWORD(Wea->wParam))
   {
      case IDC_BUTTON_CALCULATE:
           btnCalculate_OnClick(Wea);
           break;
      case IDC_BUTTON_DISPLAY:
           btnDisplay_OnClick(Wea);
           break;
   }

   return 0;
  }

  Child window controls like we added to the Form in the WM_CREATE message handler
  communicate with their parent by sending WM_COMMAND messages.  Of course, we've learned
  that associated with each message a Window Procedure receives is the handle of the
  Window the message (1st parameter) applies to, as well as the two WPARAM and LPARAM
  message specific details which carry additonal message specific information.  Since
  Windows was designed to run with high efficiency these 32 bit WPARAM and LPARAM
  parameters often carry their payloads combined into 16 byte packets of information as
  we found out in our Form2 where we used the HIWORD and LOWORD macros to extract 16 bit
  chunks.  When a button control is clicked, for example, it sends its parent's Window
  Procedure a WM_COMMAND message and the LOWORD of the WPARAM will be the Control ID of
  the button which was clicked.  Below is the Microsoft Documentation on the WM_COMMAND
  message...

                                       --Microsoft--

  WM_COMMAND

  The WM_COMMAND message is sent when the user selects a command item from a menu, when a
  control sends a notification message to its parent window, or when an accelerator
  keystroke is translated.

  WM_COMMAND

  wNotifyCode = HIWORD(wParam); // notification code
  wID = LOWORD(wParam);         // item, control, or accelerator identifier
  hwndCtl = (HWND) lParam;      // handle of control

  Parameters

  wNotifyCode  Value of the high-order word of wParam. Specifies the notification code if
               the message is from a control. If the message is from an accelerator, this
               parameter is 1. If the message is from a menu, this parameter is 0.

  wID          Value of the low-order word of wParam. Specifies the identifier of the menu
               item, control, or accelerator.

  hwndCtl      Value of lParam. Handle to the control sending the message if the message
               is from a control. Otherwise, this parameter is NULL.

  Return Values

  If an application processes this message, it should return zero.

                                      --End Microsoft--

  Their wID above is the equate/define I've been speaking of in terms of Control IDs. Note
  that there is other information contained in both wParam and lParam which my code above
  seems to be ignoring.  Specifically, the HIWORD(wParam) contains what is termed the
  notification code.  In the case of a button when it has been pressed that would be a
  define named BN_CLICKED.  Buttons are somewhat unusual among the other controls in that
  the BN_CLICKED message is oftentimes the only one of interest although there are several
  others.  So while its not absolutely perfect what I've done above, its what you'll see
  most often with regard to buttons.  In most other cases though, you have to test both
  the control ID and the notification code.  Take the Combo Box on this Form for example.
  Combo Boxes are somewhat more complex than buttons.  When the arrow expander is clicked
  to open up a Combo Box the CBN_DROPDOWN notification is sent along with the control id
  of the combobox.  An app may need to run specific code in response to that.  Once the user
  makes a selection from the dropdown list, the CBN_SELCHANGE notification is sent.  So,
  I'm just wanting to make you aware of this even though this app doesn't make use of any
  such functionality.

  Now that we've got a little bit of this sort of internal plumbing in place, we can begin
  to think about collecting information the user may have entered, and calculating some
  volumes.  Please compile & run this example though so you have a feel for what's working
  now and what isn't.
*/

//Main.cpp
#include <windows.h>
#include "ProgEx40a.h"
EVENTHANDLER  EventHandler[3];


long fnWndProc_OnCreate(lpWndEventArgs Wea)
{
 char* szBuffer[]={"Ordinary Box","Box Of Junk","Beer Crate","Wine Box","Candy Box"};
 DWORD dwStyle=WS_CHILD|WS_VISIBLE|WS_TABSTOP;
 HWND hCtl;

 Wea->hIns=((LPCREATESTRUCT)Wea->lParam)->hInstance;
 hCtl=CreateWindow("static","Choose Kind of Box",WS_CHILD|WS_VISIBLE,10,10,140,25,Wea->hWnd,(HMENU)-1,Wea->hIns,0);
 hCtl=CreateWindow("combobox","",dwStyle|CBS_DROPDOWNLIST|WS_VSCROLL,150,10,140,100,Wea->hWnd,(HMENU)IDC_COMBO_TYPE,Wea->hIns,0);
 for(unsigned int i=0; i<5; i++)
     SendMessage(hCtl,CB_INSERTSTRING,(WPARAM)-1,(LPARAM)szBuffer[i]);
 SendMessage(hCtl,CB_SETCURSEL,(WPARAM)0,0);  //|WS_TABSTOP
 hCtl=CreateWindow("static","Length of Box",WS_CHILD|WS_VISIBLE,10,53,125,25,Wea->hWnd,(HMENU)-1,Wea->hIns,0);
 hCtl=CreateWindowEx(WS_EX_CLIENTEDGE,"edit","",dwStyle,150,50,70,25,Wea->hWnd,(HMENU)IDC_EDIT_LENGTH,Wea->hIns,0);
 hCtl=CreateWindow("static","Width of Box",WS_CHILD|WS_VISIBLE,10,93,125,25,Wea->hWnd,(HMENU)-1,Wea->hIns,0);
 hCtl=CreateWindowEx(WS_EX_CLIENTEDGE,"edit","",dwStyle,150,90,70,25,Wea->hWnd,(HMENU)IDC_EDIT_WIDTH,Wea->hIns,0);
 hCtl=CreateWindow("static","Height of Box",WS_CHILD|WS_VISIBLE,10,133,125,25,Wea->hWnd,(HMENU)-1,Wea->hIns,0);
 hCtl=CreateWindowEx(WS_EX_CLIENTEDGE,"edit","",dwStyle,150,130,70,25,Wea->hWnd,(HMENU)IDC_EDIT_HEIGHT,Wea->hIns,0);
 hCtl=CreateWindow("static","Volume",WS_CHILD|WS_VISIBLE,10,183,70,25,Wea->hWnd,(HMENU)-1,Wea->hIns,0);
 hCtl=CreateWindowEx(WS_EX_CLIENTEDGE,"edit","",dwStyle,80,180,300,25,Wea->hWnd,(HMENU)IDC_EDIT_VOLUME,Wea->hIns,0);
 hCtl=CreateWindow("button","Calculate",dwStyle,245,65,120,30,Wea->hWnd,(HMENU)IDC_BUTTON_CALCULATE,Wea->hIns,0);
 hCtl=CreateWindow("button","Display",dwStyle,245,110,120,30,Wea->hWnd,(HMENU)IDC_BUTTON_DISPLAY,Wea->hIns,0);
 SetWindowText(Wea->hWnd,"Volume Of Your Box");
 SetFocus(GetDlgItem(Wea->hWnd,IDC_COMBO_TYPE));

 return 0;
}


void btnCalculate_OnClick(lpWndEventArgs Wea)
{
 MessageBox(Wea->hWnd, "You've Clicked The Calculate Button!", "Button Click Report", MB_OK);
}


void btnDisplay_OnClick(lpWndEventArgs Wea)
{
 MessageBox(Wea->hWnd, "You've Clicked The Display Button!", "Button Click Report", MB_OK);
}


long fnWndProc_OnCommand(lpWndEventArgs Wea)
{
 switch(LOWORD(Wea->wParam))
 {
    case IDC_BUTTON_CALCULATE:
         btnCalculate_OnClick(Wea);
         break;
    case IDC_BUTTON_DISPLAY:
         btnDisplay_OnClick(Wea);
         break;
 }

 return 0;
}


long fnWndProc_OnClose(lpWndEventArgs Wea)
{
 DestroyWindow(Wea->hWnd);
 PostQuitMessage(0);
 return 0;
}


void AttachEventHandlers(void)         //This procedure maps windows messages to the
{                                      //procedure which handles them.
 EventHandler[0].Code=WM_CREATE,       EventHandler[0].fnPtr=fnWndProc_OnCreate;
 EventHandler[1].Code=WM_COMMAND,      EventHandler[1].fnPtr=fnWndProc_OnCommand;
 EventHandler[2].Code=WM_CLOSE,        EventHandler[2].fnPtr=fnWndProc_OnClose;
}


long __stdcall fnWndProc(HWND hwnd, unsigned int msg, WPARAM wParam,LPARAM lParam)
{
 WndEventArgs Wea;                  //This procedure loops through the EVENTHANDER array
                                    //of structs to try to make a match with the msg parameter
 for(unsigned int i=0; i<3; i++)    //of the WndProc.  If a match is made the event handling
 {                                  //procedure is called through a function pointer -
     if(EventHandler[i].Code==msg)  //(EventHandler[i].fnPtr).  If no match is found the
     {                              //msg is passed onto DefWindowProc().
        Wea.hWnd=hwnd, Wea.lParam=lParam, Wea.wParam=wParam;
        return (*EventHandler[i].fnPtr)(&Wea);
     }
 }

 return (DefWindowProc(hwnd, msg, wParam, lParam));
}


int __stdcall WinMain(HINSTANCE hInstance, HINSTANCE hPrevIns, LPSTR lpszArgument, int iShow)
{
 char szClassName[]="Form3";
 WNDCLASSEX wc;
 MSG messages;
 HWND hWnd;

 AttachEventHandlers();
 wc.lpszClassName=szClassName;                wc.lpfnWndProc=fnWndProc;
 wc.cbSize=sizeof (WNDCLASSEX);               wc.style=CS_DBLCLKS;
 wc.hIcon=LoadIcon(NULL,IDI_APPLICATION);     wc.hInstance=hInstance;
 wc.hIconSm=LoadIcon(NULL, IDI_APPLICATION);  wc.hCursor=LoadCursor(NULL,IDC_ARROW);
 wc.hbrBackground=(HBRUSH)COLOR_BTNSHADOW;    wc.cbWndExtra=0;
 wc.lpszMenuName=NULL;                        wc.cbClsExtra=0;
 RegisterClassEx(&wc);
 hWnd=CreateWindowEx(0,szClassName,szClassName,WS_OVERLAPPEDWINDOW,200,400,400,250,HWND_DESKTOP,0,hInstance,0);
 ShowWindow(hWnd,iShow);
 while(GetMessage(&messages,NULL,0,0))
 {     //Is it not a Dialog Message?
    if(!IsDialogMessage(hWnd,&messages)) //Added this because it does special character code translations that
    {                                    //allows the use of the tab key to move focus among child window
       TranslateMessage(&messages);      //controls with the WS_TABSTOP style on the main Form.
       DispatchMessage(&messages);
    }
 }

 return messages.wParam;
}

